/*
	basic_type_info_decorator.hpp
*/
#ifndef BOOST_DLL_BASIC_TYPE_INFO_DECORATOR_HPP
#define BOOST_DLL_BASIC_TYPE_INFO_DECORATOR_HPP

#include "decorating_context.hpp"
#include "extended_type_info.hpp"
#include <string>

namespace boost
{
	namespace detail
	{
		namespace dll
		{
			class basic_type_info_decorator
			{
			public:
				basic_type_info_decorator();
				~basic_type_info_decorator();

				std::string decorate(decorating_context &context,
									 const extended_type_info &info) const;
			};
		}; // end namespace dll
	}; // end namespace detail
}; // end namespace boost

#endif // BOOST_DLL_BASIC_TYPE_INFO_DECORATOR_HPP