/*
	test.h
*/
#ifndef __TEST_H__
#define __TEST_H__

#include <string>

class _declspec(dllexport) test_class
{
};

namespace std
{
	template<typename T> struct suelz1 {};
	template<typename T> struct suelz2 {};
	template<typename T, typename S = suelz1<T> > struct suelz3 {};

	template<typename T, typename S1 = std::char_traits<T>, typename T2 = suelz2<T>, typename T3 = suelz3<T> >
	class template_test_class
	{
	};
}

namespace test_namespace
{
	class _declspec(dllexport) test_class
	{
	};
};

void _declspec(dllexport) test1();
void _declspec(dllexport) test2(char x);
void _declspec(dllexport) test3(char &x);
char _declspec(dllexport) test4(char *str);
void _declspec(dllexport) test5(const std::string &str);
void _declspec(dllexport) test6(const std::string &str1, const std::string &str2);
void _declspec(dllexport) test7(test_class a, test_class *b);

void _declspec(dllexport) class_test_plain(test_class t);
void _declspec(dllexport) class_test_plain2(test_class t1, test_class t2);
void _declspec(dllexport) class_test_ptr(test_class *t);
void _declspec(dllexport) class_test_cptr(const test_class *t);
void _declspec(dllexport) class_test_ref(test_class &t);
void _declspec(dllexport) class_test_cref(const test_class &t);

void _declspec(dllexport) class_test_mixed(test_class t1, test_class *t2);

test_class _declspec(dllexport) template_class_test_plain(test_class c, std::template_test_class<char> t);

void _declspec(dllexport) ns_class_test_plain(test_namespace::test_class t);

#endif // __TEST_H__